package com.hotwj.platform.resourceManagement.vehicleDevice.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.resourceManagement.vehicleDevice.domain.HotVehicleDevice;
import com.hotwj.platform.resourceManagement.vehicleDevice.domain.bo.HotVehicleDeviceBo;
import com.hotwj.platform.resourceManagement.vehicleDevice.domain.vo.HotVehicleDeviceVo;
import com.hotwj.platform.resourceManagement.vehicleDevice.mapper.HotVehicleDeviceMapper;
import com.hotwj.platform.resourceManagement.vehicleDevice.service.IHotVehicleDeviceService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 车辆安全设备Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-15
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotVehicleDeviceServiceImpl implements IHotVehicleDeviceService {

    private final HotVehicleDeviceMapper baseMapper;

    /**
     * 查询车辆安全设备
     *
     * @param id 主键
     * @return 车辆安全设备
     */
    @Override
    public HotVehicleDeviceVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询车辆安全设备列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 车辆安全设备分页列表
     */
    @Override
    public TableDataInfo<HotVehicleDeviceVo> queryPageList(HotVehicleDeviceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotVehicleDevice> lqw = buildQueryWrapper(bo);
        Page<HotVehicleDeviceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的车辆安全设备列表
     *
     * @param bo 查询条件
     * @return 车辆安全设备列表
     */
    @Override
    public List<HotVehicleDeviceVo> queryList(HotVehicleDeviceBo bo) {
        LambdaQueryWrapper<HotVehicleDevice> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotVehicleDevice> buildQueryWrapper(HotVehicleDeviceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotVehicleDevice> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotVehicleDevice::getId);
        lqw.eq(bo.getCompanyId() != null, HotVehicleDevice::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getVehicleId() != null, HotVehicleDevice::getVehicleId, bo.getVehicleId());
        lqw.like(StringUtils.isNotBlank(bo.getDeviceName()), HotVehicleDevice::getDeviceName, bo.getDeviceName());
        lqw.eq(bo.getIsDeleted() != null, HotVehicleDevice::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增车辆安全设备
     *
     * @param bo 车辆安全设备
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotVehicleDeviceBo bo) {
        HotVehicleDevice add = MapstructUtils.convert(bo, HotVehicleDevice.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改车辆安全设备
     *
     * @param bo 车辆安全设备
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotVehicleDeviceBo bo) {
        HotVehicleDevice update = MapstructUtils.convert(bo, HotVehicleDevice.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotVehicleDevice entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除车辆安全设备信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
